import { ChangeDetectorRef, OnDestroy, OnInit } from '@angular/core';
import 'rxjs/add/observable/if';
import 'rxjs/add/operator/take';
import { DFCommonService } from '../services/df.common.api';
import { DFFilterService } from '../services/store/df.filter.service';
import { DFQuestionControlService } from '../services/df.question.control.service';
import { DFStoreFunctions } from '../services/store/df.store.functions';
import { Env } from 'io-ng-util/lib/common/env';
import { FormGroup } from '@angular/forms';
import { Iform } from '../../construct/services/store/df.store.models';
import { QuestionBase } from '../definitions/question-base';
import { QuestionGroup } from '../definitions/question-group';
import { Store } from '@ngrx/store';
export declare class DFComponent implements OnInit, OnDestroy {
    questionGroups: Array<QuestionGroup<any>>;
    values: any;
    componentName: string;
    locals: Iform;
    formSpecs: any;
    form: FormGroup;
    savedForm: FormGroup;
    formErrors: any[];
    validations: Array<QuestionBase<any>>;
    fieldsWithParents: any[];
    questions: Array<QuestionBase<any>>;
    keyNames: string[];
    storeData: any;
    storeName: string;
    env: Env;
    private oldValues;
    private storeValues;
    private oldquestionGroups;
    private FSStore;
    private formSubscription;
    private AStore;
    private RStore;
    private FStore;
    private VStore;
    private TStore;
    private loaded;
    private cd;
    private fs;
    private qcs;
    private store;
    private DSF;
    private DFCS;
    constructor(env: Env, cd: ChangeDetectorRef, fs: DFFilterService, qcs: DFQuestionControlService, store: Store<any>, DSF: DFStoreFunctions, DFCS: DFCommonService);
    ngOnInit(): void;
    setForm(): void;
    /**
     *
     * here we subscribe to the store and await results
     * @returns {*}
     *
     * @memberOf DFComponent
     */
    awaitResults(): any;
    formSubscribe: () => void;
    /**
     * here we load data from a store if the fromStore is set
     * We do this only if the formname is different from the local name to avoid getting
     * into a loop because of the value changes;
     * @returns {*}
     *
     * @memberOf DFComponent
     */
    fromStore(store: string): any;
    requiredFromStore(): any;
    fromServer: () => void;
    watchChanges(): void;
    setDefaultValues: () => void;
    /**
     *  a function to flatten values
     *
     *
     * @memberOf DFComponent
     */
    onSubmit: (val?: boolean) => void;
    onSave: (val?: boolean, diff?: boolean) => void;
    onEdit: () => void;
    onCancel: () => void;
    onDelete: () => void;
    /**
     *  this code is triggered externallt by evaluating an onclick on a form button
     * action
     * @memberOf DFComponent
     */
    onAction: (action: any) => void;
    onValueChanged: () => void;
    evalStr: (str: string) => any;
    questionsVisible: any;
    resetQuestions(): void;
    getStoreSubscription(): any;
    onFilter(reset: boolean, keys: string[]): any;
    getAction(action: any): void;
    ngOnDestroy(): void;
    private patchValues;
    private findIdx;
    private setPath;
    /** a function that add to the original values the values from the form
     * this.form values has the highest level;
     */
    private emitValues();
    private diff;
    private check;
}
